#!/usr/bin/python3

import sys

data = sys.stdin.buffer.read()

# Add current position header
print("0x0 ?")

block = 0
size = 0
prev_mark = ''
for byte in data:
    mask = 0x80
    while mask:
        # Mark free blocks as done
        mark = '?' if (byte & mask) else '+'

        # Collect blocks with the same mark, and flush when the mark changes
        if mark != prev_mark and size:
            print(hex(block), hex(size), prev_mark)
            block += size
            size = 0

        size += 4096
        prev_mark = mark
        mask >>= 1

# Flush last chunk
print(hex(block), hex(size), prev_mark)
